Scriptname RealNamesSSEPatchMCM extends ski_configbase

import Debug
import Utility
import Game
import Input

string[] pages
string[] RaceSelectMenu
string[] SubpageMenu
string[] ListSelectMenu
string[] genericNameMenu
string[] KhajiitHonorificMenu
string[] TitlePreferenceMenu

int[] MasterIndex

RealNamesSSEPatchPlayerAlias Property scrNameGen Auto

int currentlistpage = 0
int currentlist = 0
int selectedindex = 0
int currentrace = 0

bool bUpdateLists = false

;SCRIPT VERSION
int function GetVersion()
	return 2
endfunction

Event OnVersionUpdate(int iVersion)
	if iVersion >= 2 && CurrentVersion < 2
		TitlePreferenceMenu = new string[19]
			TitlePreferenceMenu[0] = "Title > Surname and/or Epithet"
			TitlePreferenceMenu[1] = "Surname > Title and/or Epithet"
			TitlePreferenceMenu[2] = "Epithet > Title and/or Surname"
			TitlePreferenceMenu[3] = "Title and/or Surname > Epithet"
			TitlePreferenceMenu[4] = "Title and/or Epithet > Surname"
			TitlePreferenceMenu[5] = "Surname and/or Epithet > Title"
			TitlePreferenceMenu[6] = "Title > Surname"
			TitlePreferenceMenu[7] = "Title > Epithet"
			TitlePreferenceMenu[8] = "Surname > Title"
			TitlePreferenceMenu[9] = "Surname > Epithet"
			TitlePreferenceMenu[10] = "Epithet > Title"
			TitlePreferenceMenu[11] = "Epithet > Surname"
			TitlePreferenceMenu[12] = "Title > Surname > Epithet"
			TitlePreferenceMenu[13] = "Title > Epithet > Surname"
			TitlePreferenceMenu[14] = "Surname > Title > Epithet"
			TitlePreferenceMenu[15] = "Surname > Epithet > Title"
			TitlePreferenceMenu[16] = "Epithet > Title > Surname"
			TitlePreferenceMenu[17] = "Epithet > Surname > Title"
			TitlePreferenceMenu[18] = "Allow All"
	endif
endEvent

Event OnConfigInit()
	pages = new string[4]
		pages[0] = "Basic Options"
		pages[1] = "Config Options"
		pages[2] = "Name Lists"
		pages[3] = "Exceptions"

	genericNameMenu = new string[5]
		genericNameMenu[0] = "Disabled"
		genericNameMenu[1] = "Brackets"
		genericNameMenu[2] = "Brackets (New Line)"
		genericNameMenu[3] = "Comma"
		genericNameMenu[4] = "(New Line)"

	RaceSelectMenu = new string[11]
		RaceSelectMenu[0] = "Argonian"
		RaceSelectMenu[1] = "Breton"
		RaceSelectMenu[2] = "Dark Elf"
		RaceSelectMenu[3] = "High Elf"
		RaceSelectMenu[4] = "Imperial"
		RaceSelectMenu[5] = "Khajiit"
		RaceSelectMenu[6] = "Nord"
		RaceSelectMenu[7] = "Orc"
		RaceSelectMenu[8] = "Redguard"
		RaceSelectMenu[9] = "Wood Elf"
		RaceSelectMenu[10] = "Misc."

	ListSelectMenu = new string[56]
		ListSelectMenu[0] = "Generic Name Search Terms"
		ListSelectMenu[1] = "Generic Boss Search Terms"
		ListSelectMenu[2] = "Argonian Male Names"
		ListSelectMenu[3] = "Argonian Female Names"
		ListSelectMenu[4] = "Argonian Tribe Names"
		ListSelectMenu[5] = "Breton Male Names"
		ListSelectMenu[6] = "Breton Female Names"
		ListSelectMenu[7] = "Breton Surnames"
		ListSelectMenu[8] = "Dark Elf Male Names"
		ListSelectMenu[9] = "Dark Elf Female Names"
		ListSelectMenu[10] = "Dark Elf House Names"
		ListSelectMenu[11] = "Ashlander Male Names"
		ListSelectMenu[12] = "Ashlander Female Names"
		ListSelectMenu[13] = "Ashlander Tribe Names"
		ListSelectMenu[14] = "High Elf Male Names"
		ListSelectMenu[15] = "High Elf Female Names"
		ListSelectMenu[16] = "High Elf House Names"
		ListSelectMenu[17] = "Imperial Male Names"
		ListSelectMenu[18] = "Imperial Female Names"
		ListSelectMenu[19] = "Imperial Family Names"
		ListSelectMenu[20] = "Khajiit Male Names"
		ListSelectMenu[21] = "Khajiit Male Prefices"
		ListSelectMenu[22] = "Khajiit Male Suffices"
		ListSelectMenu[23] = "Khajiit Female Names"
		ListSelectMenu[24] = "Khajiit Female Prefices"
		ListSelectMenu[25] = "Khajiit Female Suffices"
		ListSelectMenu[26] = "Khajiit Tribe Names"
		ListSelectMenu[27] = "Nord Male Names"
		ListSelectMenu[28] = "Nord Female Names"
		ListSelectMenu[29] = "Nord Clan Names"
		ListSelectMenu[30] = "Orc Male Names"
		ListSelectMenu[31] = "Orc Female Names"
		ListSelectMenu[32] = "Orc Clan Names"
		ListSelectMenu[33] = "Redguard Male Names"
		ListSelectMenu[34] = "Redguard Female Names"
		ListSelectMenu[35] = "Redguard Surnames"
		ListSelectMenu[36] = "Wood Elf Male Names"
		ListSelectMenu[37] = "Wood Elf Female Names"
		ListSelectMenu[38] = "Wood Elf Tribe Names"
		ListSelectMenu[39] = "Dremora Male Names"
		ListSelectMenu[40] = "Dremora Female Names"
		ListSelectMenu[41] = "Dremora Kyn Names"
		ListSelectMenu[42] = "Giant Names"
		ListSelectMenu[43] = "Dragon Name Words (1st Word)"
		ListSelectMenu[44] = "Dragon Name Words (one syllable)"
		ListSelectMenu[45] = "Dragon Name Words (two syllable)"
		ListSelectMenu[46] = "Warrior Titles"
		ListSelectMenu[47] = "Thief Titles"
		ListSelectMenu[48] = "Mage Titles"
		ListSelectMenu[49] = "Generic Titles"
		ListSelectMenu[50] = "Boss Titles"
		ListSelectMenu[51] = "Warrior Epithets"
		ListSelectMenu[52] = "Thief Epithets"
		ListSelectMenu[53] = "Mage Epithets"
		ListSelectMenu[54] = "Generic Epithets"
		ListSelectMenu[55] = "Boss Epithets"

	SubpageMenu = new string[3]
		SubpageMenu[0] = "1"
		SubpageMenu[1] = "2"
		SubpageMenu[2] = "3"

	KhajiitHonorificMenu = new string[3]
		KhajiitHonorificMenu[0] = "Prefix > Suffix"
		KhajiitHonorificMenu[1] = "Suffix > Prefix"
		KhajiitHonorificMenu[2] = "Allow Both"

	TitlePreferenceMenu = new string[7]
		TitlePreferenceMenu[0] = "Title and/or Surname > Epithet"
		TitlePreferenceMenu[1] = "Title > Epithet"
		TitlePreferenceMenu[2] = "Surname > Epithet"
		TitlePreferenceMenu[3] = "Epithet > Surname"
		TitlePreferenceMenu[4] = "Epithet > Title"
		TitlePreferenceMenu[5] = "Epithet > Title and/or Surname"
		TitlePreferenceMenu[6] = "Allow All"

	MasterIndex = new int[127]

EndEvent

Event OnPageReset(string page)
	if page == ""
		LoadCustomContent("RealNamesSSE/RealNamesTitle.DDS", 56, 107)
	else
		UnloadCustomContent()
	endif

	if page == "Basic Options"
		SetCursorFillMode(TOP_TO_BOTTOM)

		AddHeaderOption("Everyone Has A Name")
		AddTextOption("This utility assigns names to generically named","")
		AddTextOption("characters, and even creatures such as dragons.","")
		AddEmptyOption()
		AddHeaderOption("Settings")
		AddToggleOptionST("optEnabled", "Enable Mod", scrNameGen.bEnabled)

		int strangerModeFlag
		if scrNameGen.bPeopleAreStrangersInst
			strangerModeFlag = OPTION_FLAG_DISABLED
		else
			strangerModeFlag = OPTION_FLAG_NONE
		endIf

		AddToggleOptionST("optStrangersMode", "Strangers Mode", scrNameGen.bPeopleAreStrangersMode, strangerModeFlag)
		AddToggleOptionST("optMassRenaming", "Mass Renaming", scrNameGen.bMassRenaming, strangerModeFlag)
		AddToggleOptionST("optRefreshDisplayedName", "Refresh Name", scrNameGen.bRefreshDisplayedName)

		AddMenuOptionST("optGenericName", "Keep Generic Name", GenericNameMenu[scrNameGen.iGenericName])
		AddTextOption("Title Preference:","")
		AddMenuOptionST("optTitlePreference","", TitlePreferenceMenu[scrNameGen.TitlePreference])


		SetCursorPosition(1)
		AddHeaderOption("Controls")
		AddKeyMapOptionST("optForceRenameKey", "Force Rename Key", scrNameGen.iForceRenameKey, OPTION_FLAG_WITH_UNMAP)
		AddKeyMapOptionST("optRevertNameKey", "Revert Name Key", scrNameGen.iRevertNameKey, OPTION_FLAG_WITH_UNMAP)

		AddEmptyOption()
		AddHeaderOption("Special Exclusions")
		AddToggleOptionST("optDraugrExclusion", "Exclude Draugr?", scrNameGen.bDraugrExclusion)
		AddToggleOptionST("optDremoraExclusion", "Exclude Dremora?", scrNameGen.bDremoraExclusion)
		AddToggleOptionST("optDragonExclusion", "Exclude Dragons?", scrNameGen.bDragonExclusion)
		AddToggleOptionST("optDragonPriestExclusion", "Exclude Dragon Priests?", scrNameGen.bDragonPriestExclusion)
		AddToggleOptionST("optGiantExclusion", "Exclude Giants?", scrNameGen.bGiantExclusion)
		AddToggleOptionST("optHagravenExclusion", "Exclude Hagravens?", scrNameGen.bHagravenExclusion)
		AddToggleOptionST("optCorpseExclusion", "Exclude Corpses?", scrNameGen.bCorpseExclusion)
	

	endif

	if page == "Exceptions"
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Explanation")
		AddTextOption("This mod ensures that Named NPCs do not get","")
		AddTextOption("inadvertently renamed by utilizing an uneditable","")
		AddTextOption("string of Names used in Vanilla Skyrim.","")
		AddEmptyOption()
		AddTextOption("The options provided on this page allow you to","")
		AddTextOption("add new terms to the string (if you find that the","")
		AddTextOption("mod is renaming Named NPCs) or to revert the","")
		AddTextOption("Exceptions String back to its default value.","")
		AddEmptyOption()
		AddTextOption("If you REALLY want to rename Named Vanilla NPCs","")
		AddTextOption("with this mod, you can clear the string.","")

		SetCursorPosition(1)
		AddHeaderOption("")
		AddEmptyOption()
		AddInputOptionST("optAddException","ADD AN EXCEPTION:", "...")
		AddEmptyOption()
		AddHeaderOption("")
		AddEmptyOption()
		AddTextOptionST("optRevertExceptions","", "REVERT TO DEFAULT EXCEPTIONS")
		AddEmptyOption()
		AddHeaderOption("")
		AddEmptyOption()
		AddTextOptionST("optClearExceptions","", "CLEAR ALL EXCEPTIONS")

	endif

	if page == "Config Options"
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddMenuOptionST("optRaceSelect","CONFIGURE:", RaceSelectMenu[currentrace])
		AddEmptyOption()
		AddHeaderOption("")
		AddHeaderOption("")
		if RaceSelectMenu[currentrace] == "Misc."
			AddSliderOptionST("optBossSir", "Boss Title Chance", scrNameGen.BossSirChance, "{0}%")
			AddSliderOptionST("optBossName", "Boss Epithet Chance", scrNameGen.BossNameChance, "{0}%")
			AddSliderOptionST("optDragonSyllable", "Dragon 3 Syllable Chance", scrNameGen.Dragon3SyllableChance, "{0}%")
			AddSliderOptionST("optDragonPriest1Syllable", "Dragon Priest 1 Syllable Chance", scrNameGen.DragonPriest1SyllableChance, "{0}%")
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optDraugrTitle", "Draugr Title Chance", scrNameGen.DraugrTitleChance, "{0}%")
			AddSliderOptionST("optDremoraTitle", "Dremora Title Chance", scrNameGen.DremoraTitleChance, "{0}%")
			AddSliderOptionST("optDraugrEpithet", "Draugr Epithet Chance", scrNameGen.DraugrEpithetChance, "{0}%")
			AddSliderOptionST("optDremoraEpithet", "Dremora Epithet Chance", scrNameGen.DremoraEpithetChance, "{0}%")
			AddSliderOptionST("optDraugrFamilyName", "Draugr Clan Name Chance", scrNameGen.DraugrFamilyNameChance, "{0}%")
			AddSliderOptionST("optDremoraFamilyName", "Dremora Kyn Name Chance", scrNameGen.DremoraFamilyNameChance, "{0}%")
			AddSliderOptionST("optDraugrPatronym", "Draugr Patronymic Chance", scrNameGen.DraugrPatronymicChance, "{0}%")
			AddEmptyOption()
			AddHeaderOption("")
			AddHeaderOption("")
		endif
		if RaceSelectMenu[currentrace] == "Orc"
			AddSliderOptionST("optPrefixChance", "Prefix Chance", scrNameGen.OrcFamilyPrefixChance, "{0}%")
			AddEmptyOption()
		elseif RaceSelectMenu[currentrace] == "Dark Elf"
			AddSliderOptionST("optAshlanderChance", "Ashlander Chance", scrNameGen.DunmerAshlanderChance, "{0}%")
			AddEmptyOption()
		elseif RaceSelectMenu[currentrace] == "Khajiit"
			AddMenuOptionST("optHonorificPreference", "Honorific Preference:", KhajiitHonorificMenu[scrNameGen.KhajiitHonorificPreference])
			AddEmptyOption()
			AddSliderOptionST("optMalePrefixChance", "Male Honorific Prefix Chance", scrNameGen.KhajiitMalePrefixChance, "{0}%")
			AddSliderOptionST("optFemalePrefixChance", "Female Honorific Prefix Chance", scrNameGen.KhajiitFemalePrefixChance, "{0}%")
			AddSliderOptionST("optMaleSuffixChance", "Male Honorific Suffix Chance", scrNameGen.KhajiitMaleSuffixChance, "{0}%")
			AddSliderOptionST("optFemaleSuffixChance", "Female Honorific Suffix Chance", scrNameGen.KhajiitFemaleSuffixChance, "{0}%")
		endif
		if RaceSelectMenu[currentrace] == "Argonian"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.ArgonianTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.ArgonianEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Tribe Name Chance", scrNameGen.ArgonianFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Tribe Name only Chance", scrNameGen.ArgonianFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.ArgonianOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.ArgonianOffRaceNameChance == 0
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.ArgonianBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.ArgonianDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.ArgonianAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.ArgonianImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.ArgonianKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.ArgonianNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.ArgonianOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.ArgonianRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.ArgonianBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.ArgonianBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.ArgonianDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.ArgonianAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.ArgonianImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.ArgonianKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.ArgonianNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.ArgonianOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.ArgonianRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.ArgonianBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Breton"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.BretonTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.BretonEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Surname Chance", scrNameGen.BretonFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Surname only Chance", scrNameGen.BretonFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.BretonOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.BretonOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.BretonArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.BretonDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.BretonAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.BretonImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.BretonKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.BretonNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.BretonOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.BretonRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.BretonBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.BretonArgonianName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.BretonDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.BretonAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.BretonImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.BretonKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.BretonNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.BretonOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.BretonRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.BretonBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Dark Elf"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.DunmerTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.DunmerEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "House Name Chance", scrNameGen.DunmerFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "House Name only Chance", scrNameGen.DunmerFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.DunmerOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.DunmerOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.DunmerArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.DunmerBretonName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.DunmerAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.DunmerImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.DunmerKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.DunmerNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.DunmerOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.DunmerRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.DunmerBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.DunmerArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.DunmerBretonName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.DunmerAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.DunmerImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.DunmerKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.DunmerNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.DunmerOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.DunmerRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.DunmerBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "High Elf"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.AltmerTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.AltmerEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "House Name Chance", scrNameGen.AltmerFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "House Name only Chance", scrNameGen.AltmerFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.AltmerOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.AltmerOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.AltmerArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.AltmerBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.AltmerDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.AltmerImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.AltmerKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.AltmerNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.AltmerOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.AltmerRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.AltmerBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.AltmerArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.AltmerBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.AltmerDunmerName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.AltmerImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.AltmerKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.AltmerNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.AltmerOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.AltmerRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.AltmerBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Imperial"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.ImperialTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.ImperialEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Family Name Chance", scrNameGen.ImperialFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Family Name only Chance", scrNameGen.ImperialFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.ImperialOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.ImperialOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.ImperialArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.ImperialBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.ImperialDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.ImperialAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.ImperialKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.ImperialNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.ImperialOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.ImperialRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.ImperialBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.ImperialArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.ImperialBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.ImperialDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.ImperialAltmerName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.ImperialKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.ImperialNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.ImperialOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.ImperialRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.ImperialBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Khajiit"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.KhajiitTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.KhajiitEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Tribe Name Chance", scrNameGen.KhajiitFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Tribe Name only Chance", scrNameGen.KhajiitFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.KhajiitOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.KhajiitOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.KhajiitArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.KhajiitBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.KhajiitDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.KhajiitAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.KhajiitImperialName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.KhajiitNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.KhajiitOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.KhajiitRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.KhajiitBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.KhajiitArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.KhajiitBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.KhajiitDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.KhajiitAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.KhajiitImperialName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.KhajiitNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.KhajiitOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.KhajiitRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.KhajiitBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Nord"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.NordTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.NordEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Clan Name Chance", scrNameGen.NordFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Clan Name only Chance", scrNameGen.NordFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optNordPatronym", "Patronymic Chance", scrNameGen.NordPatronymicChance, "{0}%", OPTION_FLAG_NONE)
                        AddEmptyOption()
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.NordOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.NordOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.NordArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.NordBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.NordDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.NordAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.NordImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.NordKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.NordOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.NordRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.NordBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.NordArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.NordBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.NordDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.NordAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.NordImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.NordKhajiitName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.NordOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.NordRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.NordBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Orc"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.OrcTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.OrcEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Clan Name Chance", scrNameGen.OrcFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Clan Name only Chance", scrNameGen.OrcFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.OrcOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.OrcOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.OrcArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.OrcBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.OrcDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.OrcAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.OrcImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.OrcKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.OrcNordName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.OrcRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.OrcBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.OrcArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.OrcBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.OrcDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.OrcAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.OrcImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.OrcKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.OrcNordName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.OrcRedguardName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.OrcBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Redguard"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.RedguardTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.RedguardEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Surname Chance", scrNameGen.RedguardFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Surname only Chance", scrNameGen.RedguardFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.RedguardOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.RedguardOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.RedguardArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.RedguardBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.RedguardDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.RedguardAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.RedguardImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.RedguardKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.RedguardNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.RedguardOrcName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.RedguardBosmerName, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.RedguardArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.RedguardBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.RedguardDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.RedguardAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.RedguardImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.RedguardKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.RedguardNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.RedguardOrcName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBosmer", "Enable Wood Elf Names", scrNameGen.RedguardBosmerName, OPTION_FLAG_NONE)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		elseif RaceSelectMenu[currentrace] == "Wood Elf"
			AddSliderOptionST("optTitle", "Title Chance", scrNameGen.BosmerTitleChance, "{0}%")
			AddSliderOptionST("optEpithet", "Epithet Chance", scrNameGen.BosmerEpithetChance, "{0}%")
			AddSliderOptionST("optFamilyName", "Tribe Name Chance", scrNameGen.BosmerFamilyNameChance, "{0}%", OPTION_FLAG_NONE)
			AddSliderOptionST("optFamilyNameOnly", "Tribe Name only Chance", scrNameGen.BosmerFamilyNameOnlyChance, "{0}%", OPTION_FLAG_NONE)
			AddHeaderOption("")
			AddHeaderOption("")
			AddSliderOptionST("optOffRaceName", "Off-Race Name Chance", scrNameGen.BosmerOffRaceNameChance, "{0}%")
			AddEmptyOption()
			if scrNameGen.BosmerOffRaceNameChance == 0
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.BosmerArgonianName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.BosmerBretonName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.BosmerDunmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.BosmerAltmerName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.BosmerImperialName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.BosmerKhajiitName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.BosmerNordName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.BosmerOrcName, OPTION_FLAG_DISABLED)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.BosmerRedguardName, OPTION_FLAG_DISABLED)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
			else
				AddToggleOptionST("optOffRaceArgonian", "Enable Argonian Names", scrNameGen.BosmerArgonianName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceBreton", "Enable Breton Names", scrNameGen.BosmerBretonName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceDunmer", "Enable Dark Elf Names", scrNameGen.BosmerDunmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceAltmer", "Enable High Elf Names", scrNameGen.BosmerAltmerName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceImperial", "Enable Imperial Names", scrNameGen.BosmerImperialName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceKhajiit", "Enable Khajiit Names", scrNameGen.BosmerKhajiitName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceNord", "Enable Nord Names", scrNameGen.BosmerNordName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceOrc", "Enable Orc Names", scrNameGen.BosmerOrcName, OPTION_FLAG_NONE)
				AddToggleOptionST("optOffRaceRedguard", "Enable Redguard Names", scrNameGen.BosmerRedguardName, OPTION_FLAG_NONE)
				AddToggleOption("Native Names are Always Enabled",true, OPTION_FLAG_DISABLED)
			endif
			AddHeaderOption("")
			AddHeaderOption("")
		endif
	else
		currentrace = 0
	endif

	if page == "Name Lists"
		MessageBox("REAL NAMES\n\nPlease wait a moment while " + ListSelectMenu[currentlist] + " page " + SubpageMenu[currentlistpage] + " is loaded.")
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddMenuOptionST("optListSelect", "", ListSelectMenu[currentlist])
		AddMenuOptionST("optSubpage", "PAGE:", SubpageMenu[currentlistpage])
		int index = 0
		while index < 126
			if ListSelectMenu[currentlist] == "Generic Name Search Terms"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericNameSearchTermsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericNameSearchTermsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericNameSearchTermsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Generic Boss Search Terms"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericBossSearchTermsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericBossSearchTermsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericBossSearchTermsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Argonian Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Argonian Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Argonian Tribe Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ArgonianFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Breton Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Breton Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Breton Surnames"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BretonFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dark Elf Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dark Elf Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dark Elf House Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DunmerFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Ashlander Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Ashlander Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Ashlander Tribe Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AshlanderFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "High Elf Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "High Elf Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "High Elf House Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.AltmerFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Imperial Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Imperial Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Imperial Family Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ImperialFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Male Prefices"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMalePreficesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMalePreficesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMalePreficesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Male Suffices"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleSufficesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleSufficesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitMaleSufficesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Female Prefices"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemalePreficesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemalePreficesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemalePreficesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Female Suffices"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleSufficesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleSufficesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFemaleSufficesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Khajiit Tribe Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.KhajiitFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Nord Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Nord Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Nord Clan Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.NordFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Orc Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Orc Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Orc Clan Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.OrcFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Redguard Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Redguard Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Redguard Surnames"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.RedguardFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Wood Elf Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Wood Elf Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Wood Elf Tribe Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BosmerFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Warrior Titles"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorTitlesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorTitlesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorTitlesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Thief Titles"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefTitlesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefTitlesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefTitlesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Mage Titles"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageTitlesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageTitlesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageTitlesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Generic Titles"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericTitlesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericTitlesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericTitlesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Boss Titles"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossSirLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossSirLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossSirLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Warrior Epithets"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorEpithetsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorEpithetsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.WarriorEpithetsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Thief Epithets"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefEpithetsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefEpithetsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.ThiefEpithetsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Mage Epithets"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageEpithetsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageEpithetsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.MageEpithetsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Generic Epithets"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericEpithetsLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericEpithetsLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GenericEpithetsLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Boss Epithets"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossNameLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossNameLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.BossNameLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dremora Male Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraMaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraMaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraMaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dremora Female Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFemaleFirstNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFemaleFirstNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFemaleFirstNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dremora Kyn Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFamilyNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFamilyNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DremoraFamilyNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Giant Names"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GiantNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GiantNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.GiantNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dragon Name Words (1st Word)"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonNamesLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonNamesLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonNamesLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dragon Name Words (one syllable)"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonOneSyllableLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonOneSyllableLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonOneSyllableLst3[index])
				endif
			elseif ListSelectMenu[currentlist] == "Dragon Name Words (two syllable)"
				if currentlistpage == 0
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonTwoSyllableLst1[index])
				elseif currentlistpage == 1
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonTwoSyllableLst2[index])
				elseif currentlistpage == 2
					MasterIndex[index] = AddInputOption("ENTRY:", scrNameGen.DragonTwoSyllableLst3[index])
				endif
			endif
			index += 1
		endwhile
	else
		currentlist = 0
		currentlistpage = 0
	endif
EndEvent

state optEnabled
	event OnSelectST()
		scrNameGen.bEnabled = !scrNameGen.bEnabled
		SetToggleOptionValueST(scrNameGen.bEnabled)
	endEvent
	
	event onHighlightST()
		 SetInfoText("Enable automatically assigning real names to generically named characters.")
	endEvent
endState

state optGenericName
	event OnMenuOpenST()
			SetMenuDialogOptions(genericNameMenu)
			SetMenuDialogStartIndex(scrNameGen.iGenericName)
			SetMenuDialogDefaultIndex(0)
	endEvent

	event OnMenuAcceptST(int index)
			scrNameGen.iGenericName = index
			SetMenuOptionValueST(genericNameMenu[scrNameGen.iGenericName])
	endEvent
	
	event OnHighlightST()
		SetInfoText("If enabled, keeps the original generic name in addition to the new name.\nThis helps keep an understanding or a person's role, but some may find it breaks immersion.")
	endEvent
endState

state optMassRenaming
	event OnSelectST()
		if !scrNameGen.bPeopleAreStrangersInst
			scrNameGen.bMassRenaming = !scrNameGen.bMassRenaming
			SetToggleOptionValueST(scrNameGen.bMassRenaming)
		endif
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Turn off if this causes degraded performance.\nAllows all valid NPCs in range to be renamed when triggered (unless in Strangers Mode).")
	endEvent
endState

state optRefreshDisplayedName
	event OnSelectST()
		scrNameGen.bRefreshDisplayedName = !scrNameGen.bRefreshDisplayedName
		SetToggleOptionValueST(scrNameGen.bRefreshDisplayedName)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Turn off if the brief flicker renaming may cause is problematic.\nIf not enabled, you will have to look away and then look back before the new name is displayed.")
	endEvent
endState

state optForceRenameKey
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrNameGen.iForceRenameKey = keyCode
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("If set, this key will force assignment of a new name to a targeted actor.")
	endEvent
endState

state optRevertNameKey
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrNameGen.iRevertNameKey = keyCode
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("If set, this key will remove any assigned names on the targeted actor.\nAfter using this, you must use the Force New Name key to assign another name.")
	endEvent
endState

state optStrangersMode
	event OnSelectST()
		if !scrNameGen.bPeopleAreStrangersInst
			scrNameGen.bPeopleAreStrangersMode = !scrNameGen.bPeopleAreStrangersMode
			SetToggleOptionValueST(scrNameGen.bPeopleAreStrangersMode)
		endIf
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, actors will not be named until they are activated for the first time.\nIf you have People Are Strangers installed, this option is always enabled.")
	endEvent
endState

state optDraugrExclusion
	event OnSelectST()
			scrNameGen.bDraugrExclusion = !scrNameGen.bDraugrExclusion
			SetToggleOptionValueST(scrNameGen.bDraugrExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Draugr can be assigned Nord names.\nIf enabled, draugr will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optDremoraExclusion
	event OnSelectST()
			scrNameGen.bDremoraExclusion = !scrNameGen.bDremoraExclusion
			SetToggleOptionValueST(scrNameGen.bDremoraExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, dremora will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optDragonExclusion
	event OnSelectST()
			scrNameGen.bDragonExclusion = !scrNameGen.bDragonExclusion
			SetToggleOptionValueST(scrNameGen.bDragonExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, dragons will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optDragonPriestExclusion
	event OnSelectST()
			scrNameGen.bDragonPriestExclusion = !scrNameGen.bDragonExclusion
			SetToggleOptionValueST(scrNameGen.bDragonExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, dragon priests will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optGiantExclusion
	event OnSelectST()
			scrNameGen.bGiantExclusion = !scrNameGen.bGiantExclusion
			SetToggleOptionValueST(scrNameGen.bGiantExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, giants will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optHagravenExclusion
	event OnSelectST()
			scrNameGen.bHagravenExclusion = !scrNameGen.bHagravenExclusion
			SetToggleOptionValueST(scrNameGen.bHagravenExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Hagravens can be assigned Breton female first names.\nIf enabled, hagravens will not be renamed.\nThis is not required for compatibility, only for preference.")
	endEvent
endState

state optCorpseExclusion
	event OnSelectST()
			scrNameGen.bCorpseExclusion = !scrNameGen.bCorpseExclusion
			SetToggleOptionValueST(scrNameGen.bCorpseExclusion)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("If enabled, corpses will not be renamed.\nDead men tell no tales.")
	endEvent
endState

Bool Function WarnKeyConflict(String ConflictControl, String ConflictName)
;a helper function for hotkey assignment check
;shows OK/cancel dialog to user; returns True:OK or False:Cancel
	return ShowMessage("This key is already mapped to:\n" + conflictControl + "\n(" + conflictName + ")\nAre you sure you want to continue?", true, "Yes", "No")
EndFunction

;provides key conflict information to other mods
string function GetCustomControl(int keyCode)
;helper to notify other plugins of keymapping conflict
    if keyCode == scrNameGen.iForceRenameKey
        return "Force New Name"
	ElseIf keyCode == scrNameGen.iRevertNameKey
		return "Revert Name"
    Else
        return ""
    endIf
endFunction

event onConfigClose()
	scrNameGen.GotoState("UpdateSettings")

	if bUpdateLists
		bUpdateLists = false
		scrNameGen.GotoState("UpdateLists")
	endif

endEvent


State optAddException

Event OnInputOpenST()
	SetInputDialogStartText("")
EndEvent

Event OnInputAcceptST(string entry)
	scrNameGen.PlayerExceptions += entry + ","
EndEvent

EndState


State optRevertExceptions

Event OnSelectST()
	if ShowMessage("ARE YOU SURE?\n\nThis will clear any Exceptions\nthat you may have added.", true, "Yes, I'm Sure", "No!")
		scrNameGen.GotoState("ResetExceptions")
	endif
EndEvent

EndState


State optClearExceptions

Event OnSelectST()
	if ShowMessage("ARE YOU SURE?\n\nThis will clear all exceptions and\nmay cause undesired renames.\n\nFor example: Ulfric Stormcloak will return 'Stormcloak' and be flagged as renameable.\n\nHowever, this is only an issue with NPCs\nwho you have not yet interacted with.", true, "Yes, I'm Sure", "No!")
		scrNameGen.Exceptions1 = ""
		scrNameGen.Exceptions2 = ""
		scrNameGen.Exceptions3 = ""
		scrNameGen.ExceptionsINPC = ""
		scrNameGen.PlayerExceptions = ","
	endif
EndEvent

EndState


State optListSelect

Event OnMenuOpenST()
	SetMenuDialogStartIndex(currentlist)
	SetMenuDialogOptions(ListSelectMenu)
EndEvent

Event OnMenuAcceptST(int index)
	currentlist = index
	ForcePageReset()
EndEvent

Event OnHighlightST()
	SetInfoText("Select the List to view.")
EndEvent

EndState


State optSubpage

Event OnMenuOpenST()
	SetMenuDialogStartIndex(currentlistpage)
	SetMenuDialogOptions(SubPageMenu)
EndEvent

Event OnMenuAcceptST(int index)
	currentlistpage = index
	ForcePageReset()
EndEvent

Event OnHighlightST()
	SetInfoText("Select active page. Each page contains 126 entries.")
EndEvent

EndState


Event OnOptionInputOpen(int option)

	selectedindex = 0

	while MasterIndex[selectedindex] != option
		selectedindex += 1
	endwhile

	if ListSelectMenu[currentlist] == "Generic Name Search Terms"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.GenericNameSearchTermsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.GenericNameSearchTermsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.GenericNameSearchTermsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Generic Boss Search Terms"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.GenericBossSearchTermsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.GenericBossSearchTermsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.GenericBossSearchTermsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ArgonianMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ArgonianMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ArgonianMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ArgonianFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ArgonianFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ArgonianFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Tribe Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ArgonianFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ArgonianFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ArgonianFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Breton Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BretonMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BretonMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BretonMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Breton Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BretonFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BretonFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BretonFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Breton Surnames"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BretonFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BretonFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BretonFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DunmerMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DunmerMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DunmerMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DunmerFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DunmerFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DunmerFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf House Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DunmerFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DunmerFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DunmerFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AshlanderMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AshlanderMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AshlanderMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AshlanderFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AshlanderFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AshlanderFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Tribe Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AshlanderFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AshlanderFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AshlanderFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "High Elf Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AltmerMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AltmerMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AltmerMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "High Elf Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AltmerFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AltmerFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AltmerFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "High Elf House Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.AltmerFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.AltmerFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.AltmerFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ImperialMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ImperialMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ImperialMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ImperialFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ImperialFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ImperialFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Family Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ImperialFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ImperialFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ImperialFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Prefices"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitMalePreficesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitMalePreficesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitMalePreficesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Suffices"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitMaleSufficesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitMaleSufficesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitMaleSufficesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Prefices"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitFemalePreficesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitFemalePreficesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitFemalePreficesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Suffices"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitFemaleSufficesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitFemaleSufficesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitFemaleSufficesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Tribe Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.KhajiitFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.KhajiitFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.KhajiitFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Nord Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.NordMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.NordMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.NordMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Nord Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.NordFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.NordFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.NordFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Nord Clan Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.NordFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.NordFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.NordFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Orc Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.OrcMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.OrcMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.OrcMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Orc Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.OrcFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.OrcFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.OrcFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Orc Clan Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.OrcFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.OrcFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.OrcFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.RedguardMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.RedguardMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.RedguardMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.RedguardFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.RedguardFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.RedguardFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Surnames"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.RedguardFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.RedguardFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.RedguardFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BosmerMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BosmerMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BosmerMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BosmerFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BosmerFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BosmerFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Tribe Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BosmerFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BosmerFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BosmerFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Male Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DremoraMaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DremoraMaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DremoraMaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Female Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DremoraFemaleFirstNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DremoraFemaleFirstNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DremoraFemaleFirstNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Kyn Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DremoraFamilyNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DremoraFamilyNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DremoraFamilyNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Warrior Titles"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.WarriorTitlesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.WarriorTitlesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.WarriorTitlesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Thief Titles"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ThiefTitlesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ThiefTitlesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ThiefTitlesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Mage Titles"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.MageTitlesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.MageTitlesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.MageTitlesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Generic Titles"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.GenericTitlesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.GenericTitlesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.GenericTitlesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Boss Titles"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BossSirLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BossSirLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BossSirLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Warrior Epithets"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.WarriorEpithetsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.WarriorEpithetsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.WarriorEpithetsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Thief Epithets"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.ThiefEpithetsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.ThiefEpithetsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.ThiefEpithetsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Mage Epithets"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.MageEpithetsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.MageEpithetsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.MageEpithetsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Generic Epithets"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.GenericEpithetsLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.GenericEpithetsLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.GenericEpithetsLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Boss Epithets"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.BossNameLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.BossNameLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.BossNameLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Giant Names"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.GiantNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.GiantNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.GiantNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (1st Word)"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DragonNamesLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DragonNamesLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DragonNamesLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (one syllable)"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DragonOneSyllableLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DragonOneSyllableLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DragonOneSyllableLst3[selectedindex])
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (two syllable)"
		if currentlistpage == 0
			SetInputDialogStartText(scrNameGen.DragonTwoSyllableLst1[selectedindex])
		elseif currentlistpage == 1
			SetInputDialogStartText(scrNameGen.DragonTwoSyllableLst2[selectedindex])
		elseif currentlistpage == 2
			SetInputDialogStartText(scrNameGen.DragonTwoSyllableLst3[selectedindex])
		endif
	endif

EndEvent

Event OnOptionInputAccept(int option, string entry)

	SetInputOptionValue(option, entry)

	if ListSelectMenu[currentlist] == "Generic Name Search Terms"
		if currentlistpage == 0
			scrNameGen.GenericNameSearchTermsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.GenericNameSearchTermsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.GenericNameSearchTermsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Generic Boss Search Terms"
		if currentlistpage == 0
			scrNameGen.GenericBossSearchTermsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.GenericBossSearchTermsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.GenericBossSearchTermsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Male Names"
		if currentlistpage == 0
			scrNameGen.ArgonianMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ArgonianMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ArgonianMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Female Names"
		if currentlistpage == 0
			scrNameGen.ArgonianFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ArgonianFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ArgonianFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Argonian Tribe Names"
		if currentlistpage == 0
			scrNameGen.ArgonianFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ArgonianFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ArgonianFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Breton Male Names"
		if currentlistpage == 0
			scrNameGen.BretonMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BretonMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BretonMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Breton Female Names"
		if currentlistpage == 0
			scrNameGen.BretonFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BretonFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BretonFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Breton Surnames"
		if currentlistpage == 0
			scrNameGen.BretonFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BretonFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BretonFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf Male Names"
		if currentlistpage == 0
			scrNameGen.DunmerMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DunmerMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DunmerMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf Female Names"
		if currentlistpage == 0
			scrNameGen.DunmerFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DunmerFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DunmerFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dark Elf House Names"
		if currentlistpage == 0
			scrNameGen.DunmerFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DunmerFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DunmerFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Male Names"
		if currentlistpage == 0
			scrNameGen.AshlanderMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AshlanderMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AshlanderMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Female Names"
		if currentlistpage == 0
			scrNameGen.AshlanderFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AshlanderFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AshlanderFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Ashlander Tribe Names"
		if currentlistpage == 0
			scrNameGen.AshlanderFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AshlanderFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AshlanderFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "High Elf Male Names"
		if currentlistpage == 0
			scrNameGen.AltmerMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AltmerMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AltmerMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "High Elf Female Names"
		if currentlistpage == 0
			scrNameGen.AltmerFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AltmerFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AltmerFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "High Elf House Names"
		if currentlistpage == 0
			scrNameGen.AltmerFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.AltmerFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.AltmerFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Male Names"
		if currentlistpage == 0
			scrNameGen.ImperialMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ImperialMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ImperialMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Female Names"
		if currentlistpage == 0
			scrNameGen.ImperialFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ImperialFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ImperialFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Imperial Family Names"
		if currentlistpage == 0
			scrNameGen.ImperialFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ImperialFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ImperialFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Names"
		if currentlistpage == 0
			scrNameGen.KhajiitMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Prefices"
		if currentlistpage == 0
			scrNameGen.KhajiitMalePreficesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitMalePreficesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitMalePreficesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Male Suffices"
		if currentlistpage == 0
			scrNameGen.KhajiitMaleSufficesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitMaleSufficesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitMaleSufficesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Names"
		if currentlistpage == 0
			scrNameGen.KhajiitFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Prefices"
		if currentlistpage == 0
			scrNameGen.KhajiitFemalePreficesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitFemalePreficesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitFemalePreficesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Female Suffices"
		if currentlistpage == 0
			scrNameGen.KhajiitFemaleSufficesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitFemaleSufficesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitFemaleSufficesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Khajiit Tribe Names"
		if currentlistpage == 0
			scrNameGen.KhajiitFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.KhajiitFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.KhajiitFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Nord Male Names"
		if currentlistpage == 0
			scrNameGen.NordMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.NordMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.NordMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Nord Female Names"
		if currentlistpage == 0
			scrNameGen.NordFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.NordFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.NordFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Nord Clan Names"
		if currentlistpage == 0
			scrNameGen.NordFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.NordFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.NordFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Orc Male Names"
		if currentlistpage == 0
			scrNameGen.OrcMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.OrcMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.OrcMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Orc Female Names"
		if currentlistpage == 0
			scrNameGen.OrcFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.OrcFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.OrcFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Orc Clan Names"
		if currentlistpage == 0
			scrNameGen.OrcFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.OrcFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.OrcFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Male Names"
		if currentlistpage == 0
			scrNameGen.RedguardMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.RedguardMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.RedguardMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Female Names"
		if currentlistpage == 0
			scrNameGen.RedguardFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.RedguardFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.RedguardFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Redguard Surnames"
		if currentlistpage == 0
			scrNameGen.RedguardFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.RedguardFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.RedguardFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Male Names"
		if currentlistpage == 0
			scrNameGen.BosmerMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BosmerMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BosmerMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Female Names"
		if currentlistpage == 0
			scrNameGen.BosmerFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BosmerFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BosmerFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Wood Elf Tribe Names"
		if currentlistpage == 0
			scrNameGen.BosmerFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BosmerFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BosmerFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Male Names"
		if currentlistpage == 0
			scrNameGen.DremoraMaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DremoraMaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DremoraMaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Female Names"
		if currentlistpage == 0
			scrNameGen.DremoraFemaleFirstNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DremoraFemaleFirstNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DremoraFemaleFirstNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dremora Kyn Names"
		if currentlistpage == 0
			scrNameGen.DremoraFamilyNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DremoraFamilyNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DremoraFamilyNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Warrior Titles"
		if currentlistpage == 0
			scrNameGen.WarriorTitlesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.WarriorTitlesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.WarriorTitlesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Thief Titles"
		if currentlistpage == 0
			scrNameGen.ThiefTitlesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ThiefTitlesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ThiefTitlesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Mage Titles"
		if currentlistpage == 0
			scrNameGen.MageTitlesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.MageTitlesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.MageTitlesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Generic Titles"
		if currentlistpage == 0
			scrNameGen.GenericTitlesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.GenericTitlesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.GenericTitlesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Boss Titles"
		if currentlistpage == 0
			scrNameGen.BossSirLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BossSirLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BossSirLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Warrior Epithets"
		if currentlistpage == 0
			scrNameGen.WarriorEpithetsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.WarriorEpithetsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.WarriorEpithetsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Thief Epithets"
		if currentlistpage == 0
			scrNameGen.ThiefEpithetsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.ThiefEpithetsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.ThiefEpithetsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Mage Epithets"
		if currentlistpage == 0
			scrNameGen.MageEpithetsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.MageEpithetsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.MageEpithetsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Generic Epithets"
		if currentlistpage == 0
			scrNameGen.GenericEpithetsLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.GenericEpithetsLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.GenericEpithetsLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Boss Epithets"
		if currentlistpage == 0
			scrNameGen.BossNameLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.BossNameLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.BossNameLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Giant Names"
		if currentlistpage == 0
			scrNameGen.GiantNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.GiantNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.GiantNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (1st Word)"
		if currentlistpage == 0
			scrNameGen.DragonNamesLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DragonNamesLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DragonNamesLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (one syllable)"
		if currentlistpage == 0
			scrNameGen.DragonOneSyllableLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DragonOneSyllableLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DragonOneSyllableLst3[selectedindex] = entry
		endif
	elseif ListSelectMenu[currentlist] == "Dragon Name Words (two syllable)"
		if currentlistpage == 0
			scrNameGen.DragonTwoSyllableLst1[selectedindex] = entry
		elseif currentlistpage == 1
			scrNameGen.DragonTwoSyllableLst2[selectedindex] = entry
		elseif currentlistpage == 2
			scrNameGen.DragonTwoSyllableLst3[selectedindex] = entry
		endif
	endif

	bUpdateLists = true

EndEvent


State optTitlePreference

Event OnMenuOpenST()
	SetMenuDialogStartIndex(scrNameGen.TitlePreference)
	SetMenuDialogOptions(TitlePreferenceMenu)
EndEvent

Event OnMenuAcceptST(int index)
	scrNameGen.TitlePreference = index
	ForcePageReset()
EndEvent

Event OnHighlightST()
	SetInfoText("Determine how Epithets, Titles, and Surnames interact.\nTerms on the left override terms on the right.\nALLOW ALL: All terms may be applied, with no override.")
EndEvent

EndState


State optHonorificPreference

Event OnMenuOpenST()
	SetMenuDialogStartIndex(scrNameGen.KhajiitHonorificPreference)
	SetMenuDialogOptions(KhajiitHonorificMenu)
EndEvent

Event OnMenuAcceptST(int index)
	scrNameGen.KhajiitHonorificPreference = index
	ForcePageReset()
EndEvent

Event OnHighlightST()
	SetInfoText("Determine how Khajiit honroifics interact with eachother.\nTerms on the left override terms on the right.\nALLOW BOTH: Both terms may be applied, with no override.")
EndEvent

EndState


State optRaceSelect

Event OnMenuOpenST()
	SetMenuDialogStartIndex(currentrace)
	SetMenuDialogOptions(RaceSelectMenu)
EndEvent

Event OnMenuAcceptST(int index)
	currentrace = index
	ForcePageReset()
EndEvent

Event OnHighlightST()
	SetInfoText("Select the Race to configure.")
EndEvent

EndState


State optOffRaceArgonian

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonArgonianName = !scrNameGen.BretonArgonianName
		SetToggleOptionValueST(scrNameGen.BretonArgonianName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerArgonianName = !scrNameGen.DunmerArgonianName
		SetToggleOptionValueST(scrNameGen.DunmerArgonianName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerArgonianName = !scrNameGen.AltmerArgonianName
		SetToggleOptionValueST(scrNameGen.AltmerArgonianName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialArgonianName = !scrNameGen.ImperialArgonianName
		SetToggleOptionValueST(scrNameGen.ImperialArgonianName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitArgonianName = !scrNameGen.KhajiitArgonianName
		SetToggleOptionValueST(scrNameGen.KhajiitArgonianName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordArgonianName = !scrNameGen.NordArgonianName
		SetToggleOptionValueST(scrNameGen.NordArgonianName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcArgonianName = !scrNameGen.OrcArgonianName
		SetToggleOptionValueST(scrNameGen.OrcArgonianName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardArgonianName = !scrNameGen.RedguardArgonianName
		SetToggleOptionValueST(scrNameGen.RedguardArgonianName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerArgonianName = !scrNameGen.BosmerArgonianName
		SetToggleOptionValueST(scrNameGen.BosmerArgonianName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Argonian names.")
EndEvent

EndState


State optOffRaceBreton

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianBretonName = !scrNameGen.ArgonianBretonName
		SetToggleOptionValueST(scrNameGen.ArgonianBretonName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerBretonName = !scrNameGen.DunmerBretonName
		SetToggleOptionValueST(scrNameGen.DunmerBretonName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerBretonName = !scrNameGen.AltmerBretonName
		SetToggleOptionValueST(scrNameGen.AltmerBretonName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialBretonName = !scrNameGen.ImperialBretonName
		SetToggleOptionValueST(scrNameGen.ImperialBretonName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitBretonName = !scrNameGen.KhajiitBretonName
		SetToggleOptionValueST(scrNameGen.KhajiitBretonName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordBretonName = !scrNameGen.NordBretonName
		SetToggleOptionValueST(scrNameGen.NordBretonName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcBretonName = !scrNameGen.OrcBretonName
		SetToggleOptionValueST(scrNameGen.OrcBretonName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardBretonName = !scrNameGen.RedguardBretonName
		SetToggleOptionValueST(scrNameGen.RedguardBretonName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerBretonName = !scrNameGen.BosmerBretonName
		SetToggleOptionValueST(scrNameGen.BosmerBretonName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Breton names.")
EndEvent

EndState


State optOffRaceDunmer

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianDunmerName = !scrNameGen.ArgonianDunmerName
		SetToggleOptionValueST(scrNameGen.ArgonianDunmerName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonDunmerName = !scrNameGen.BretonDunmerName
		SetToggleOptionValueST(scrNameGen.BretonDunmerName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerDunmerName = !scrNameGen.AltmerDunmerName
		SetToggleOptionValueST(scrNameGen.AltmerDunmerName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialDunmerName = !scrNameGen.ImperialDunmerName
		SetToggleOptionValueST(scrNameGen.ImperialDunmerName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitDunmerName = !scrNameGen.KhajiitDunmerName
		SetToggleOptionValueST(scrNameGen.KhajiitDunmerName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordDunmerName = !scrNameGen.NordDunmerName
		SetToggleOptionValueST(scrNameGen.NordDunmerName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcDunmerName = !scrNameGen.OrcDunmerName
		SetToggleOptionValueST(scrNameGen.OrcDunmerName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardDunmerName = !scrNameGen.RedguardDunmerName
		SetToggleOptionValueST(scrNameGen.RedguardDunmerName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerDunmerName = !scrNameGen.BosmerDunmerName
		SetToggleOptionValueST(scrNameGen.BosmerDunmerName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Dark Elf names.")
EndEvent

EndState


State optOffRaceAltmer

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianAltmerName = !scrNameGen.ArgonianAltmerName
		SetToggleOptionValueST(scrNameGen.ArgonianAltmerName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonAltmerName = !scrNameGen.BretonAltmerName
		SetToggleOptionValueST(scrNameGen.BretonAltmerName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerAltmerName = !scrNameGen.DunmerAltmerName
		SetToggleOptionValueST(scrNameGen.DunmerAltmerName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialAltmerName = !scrNameGen.ImperialAltmerName
		SetToggleOptionValueST(scrNameGen.ImperialAltmerName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitAltmerName = !scrNameGen.KhajiitAltmerName
		SetToggleOptionValueST(scrNameGen.KhajiitAltmerName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordAltmerName = !scrNameGen.NordAltmerName
		SetToggleOptionValueST(scrNameGen.NordAltmerName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcAltmerName = !scrNameGen.OrcAltmerName
		SetToggleOptionValueST(scrNameGen.OrcAltmerName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardAltmerName = !scrNameGen.RedguardAltmerName
		SetToggleOptionValueST(scrNameGen.RedguardAltmerName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerAltmerName = !scrNameGen.BosmerAltmerName
		SetToggleOptionValueST(scrNameGen.BosmerAltmerName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned High Elf names.")
EndEvent

EndState


State optOffRaceImperial

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianImperialName = !scrNameGen.ArgonianImperialName
		SetToggleOptionValueST(scrNameGen.ArgonianImperialName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonImperialName = !scrNameGen.BretonImperialName
		SetToggleOptionValueST(scrNameGen.BretonImperialName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerImperialName = !scrNameGen.DunmerImperialName
		SetToggleOptionValueST(scrNameGen.DunmerImperialName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerImperialName = !scrNameGen.AltmerImperialName
		SetToggleOptionValueST(scrNameGen.AltmerImperialName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitImperialName = !scrNameGen.KhajiitImperialName
		SetToggleOptionValueST(scrNameGen.KhajiitImperialName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordImperialName = !scrNameGen.NordImperialName
		SetToggleOptionValueST(scrNameGen.NordImperialName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcImperialName = !scrNameGen.OrcImperialName
		SetToggleOptionValueST(scrNameGen.OrcImperialName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardImperialName = !scrNameGen.RedguardImperialName
		SetToggleOptionValueST(scrNameGen.RedguardImperialName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerImperialName = !scrNameGen.BosmerImperialName
		SetToggleOptionValueST(scrNameGen.BosmerImperialName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Imperial names.")
EndEvent

EndState


State optOffRaceKhajiit

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianKhajiitName = !scrNameGen.ArgonianKhajiitName
		SetToggleOptionValueST(scrNameGen.ArgonianKhajiitName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonKhajiitName = !scrNameGen.BretonKhajiitName
		SetToggleOptionValueST(scrNameGen.BretonKhajiitName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerKhajiitName = !scrNameGen.DunmerKhajiitName
		SetToggleOptionValueST(scrNameGen.DunmerKhajiitName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerKhajiitName = !scrNameGen.AltmerKhajiitName
		SetToggleOptionValueST(scrNameGen.AltmerKhajiitName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialKhajiitName = !scrNameGen.ImperialKhajiitName
		SetToggleOptionValueST(scrNameGen.ImperialKhajiitName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordKhajiitName = !scrNameGen.NordKhajiitName
		SetToggleOptionValueST(scrNameGen.NordKhajiitName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcKhajiitName = !scrNameGen.OrcKhajiitName
		SetToggleOptionValueST(scrNameGen.OrcKhajiitName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardKhajiitName = !scrNameGen.RedguardKhajiitName
		SetToggleOptionValueST(scrNameGen.RedguardKhajiitName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerKhajiitName = !scrNameGen.BosmerKhajiitName
		SetToggleOptionValueST(scrNameGen.BosmerKhajiitName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Khajiit names.")
EndEvent

EndState


State optOffRaceNord

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianNordName = !scrNameGen.ArgonianNordName
		SetToggleOptionValueST(scrNameGen.ArgonianNordName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonNordName = !scrNameGen.BretonNordName
		SetToggleOptionValueST(scrNameGen.BretonNordName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerNordName = !scrNameGen.DunmerNordName
		SetToggleOptionValueST(scrNameGen.DunmerNordName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerNordName = !scrNameGen.AltmerNordName
		SetToggleOptionValueST(scrNameGen.AltmerNordName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialNordName = !scrNameGen.ImperialNordName
		SetToggleOptionValueST(scrNameGen.ImperialNordName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitNordName = !scrNameGen.KhajiitNordName
		SetToggleOptionValueST(scrNameGen.KhajiitNordName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcNordName = !scrNameGen.OrcNordName
		SetToggleOptionValueST(scrNameGen.OrcNordName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardNordName = !scrNameGen.RedguardNordName
		SetToggleOptionValueST(scrNameGen.RedguardNordName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerNordName = !scrNameGen.BosmerNordName
		SetToggleOptionValueST(scrNameGen.BosmerNordName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Nord names.")
EndEvent

EndState


State optOffRaceOrc

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianOrcName = !scrNameGen.ArgonianOrcName
		SetToggleOptionValueST(scrNameGen.ArgonianOrcName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonOrcName = !scrNameGen.BretonOrcName
		SetToggleOptionValueST(scrNameGen.BretonOrcName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerOrcName = !scrNameGen.DunmerOrcName
		SetToggleOptionValueST(scrNameGen.DunmerOrcName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerOrcName = !scrNameGen.AltmerOrcName
		SetToggleOptionValueST(scrNameGen.AltmerOrcName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialOrcName = !scrNameGen.ImperialOrcName
		SetToggleOptionValueST(scrNameGen.ImperialOrcName)
		if scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitOrcName = !scrNameGen.KhajiitOrcName
		SetToggleOptionValueST(scrNameGen.KhajiitOrcName)
		if scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordOrcName = !scrNameGen.NordOrcName
		SetToggleOptionValueST(scrNameGen.NordOrcName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardOrcName = !scrNameGen.RedguardOrcName
		SetToggleOptionValueST(scrNameGen.RedguardOrcName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerOrcName = !scrNameGen.BosmerOrcName
		SetToggleOptionValueST(scrNameGen.BosmerOrcName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Orc names.")
EndEvent

EndState


State optOffRaceRedguard

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianRedguardName = !scrNameGen.ArgonianRedguardName
		SetToggleOptionValueST(scrNameGen.ArgonianRedguardName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonRedguardName = !scrNameGen.BretonRedguardName
		SetToggleOptionValueST(scrNameGen.BretonRedguardName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerRedguardName = !scrNameGen.DunmerRedguardName
		SetToggleOptionValueST(scrNameGen.DunmerRedguardName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerRedguardName = !scrNameGen.AltmerRedguardName
		SetToggleOptionValueST(scrNameGen.AltmerRedguardName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialRedguardName = !scrNameGen.ImperialRedguardName
		SetToggleOptionValueST(scrNameGen.ImperialRedguardName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitRedguardName = !scrNameGen.KhajiitRedguardName
		SetToggleOptionValueST(scrNameGen.KhajiitRedguardName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordRedguardName = !scrNameGen.NordRedguardName
		SetToggleOptionValueST(scrNameGen.NordRedguardName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcRedguardName = !scrNameGen.OrcRedguardName
		SetToggleOptionValueST(scrNameGen.OrcRedguardName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerRedguardName = !scrNameGen.BosmerRedguardName
		SetToggleOptionValueST(scrNameGen.BosmerRedguardName)
		if scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Redguard names.")
EndEvent

EndState


State optOffRaceBosmer

Event OnSelectST()
	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianBosmerName = !scrNameGen.ArgonianBosmerName
		SetToggleOptionValueST(scrNameGen.ArgonianBosmerName)
		if scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonBosmerName = !scrNameGen.BretonBosmerName
		SetToggleOptionValueST(scrNameGen.BretonBosmerName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerBosmerName = !scrNameGen.DunmerBosmerName
		SetToggleOptionValueST(scrNameGen.DunmerBosmerName)
		if scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerBosmerName = !scrNameGen.AltmerBosmerName
		SetToggleOptionValueST(scrNameGen.AltmerBosmerName)
		if scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialBosmerName = !scrNameGen.ImperialBosmerName
		SetToggleOptionValueST(scrNameGen.ImperialBosmerName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitBosmerName = !scrNameGen.KhajiitBosmerName
		SetToggleOptionValueST(scrNameGen.KhajiitBosmerName)
		if scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordBosmerName = !scrNameGen.NordBosmerName
		SetToggleOptionValueST(scrNameGen.NordBosmerName)
		if scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcBosmerName = !scrNameGen.OrcBosmerName
		SetToggleOptionValueST(scrNameGen.OrcBosmerName)
		if scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcOffRaceNameChance = 0
			ForcePageReset()
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardBosmerName = !scrNameGen.RedguardBosmerName
		SetToggleOptionValueST(scrNameGen.RedguardBosmerName)
		if scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardOffRaceNameChance = 0
			ForcePageReset()
		endif
	endif
EndEvent

Event OnHighlightST()
	SetInfoText("If Off-Race Name Chance is greater than Zero, this toggle controls whether or not members of the selected Race can be assigned Wood Elf names.")
EndEvent

EndState


State optFamilyName

Event OnSliderOpenST()

	if RaceSelectMenu[currentrace] == "Argonian"
		SetSliderDialogStartValue(scrNameGen.ArgonianFamilyNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Breton"
		SetSliderDialogStartValue(scrNameGen.BretonFamilyNameChance)
		SetSliderDialogDefaultValue(20)
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		SetSliderDialogStartValue(scrNameGen.DunmerFamilyNameChance)
		SetSliderDialogDefaultValue(80)
	elseif RaceSelectMenu[currentrace] == "High Elf"
		SetSliderDialogStartValue(scrNameGen.AltmerFamilyNameChance)
		SetSliderDialogDefaultValue(10)
	elseif RaceSelectMenu[currentrace] == "Imperial"
		SetSliderDialogStartValue(scrNameGen.ImperialFamilyNameChance)
		SetSliderDialogDefaultValue(90)
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		SetSliderDialogStartValue(scrNameGen.KhajiitFamilyNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Nord"
		SetSliderDialogStartValue(scrNameGen.NordFamilyNameChance)
		SetSliderDialogDefaultValue(23)
	elseif RaceSelectMenu[currentrace] == "Orc"
		SetSliderDialogStartValue(scrNameGen.OrcFamilyNameChance)
		SetSliderDialogDefaultValue(80)
	elseif RaceSelectMenu[currentrace] == "Redguard"
		SetSliderDialogStartValue(scrNameGen.RedguardFamilyNameChance)
		SetSliderDialogDefaultValue(2)
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		SetSliderDialogStartValue(scrNameGen.BosmerFamilyNameChance)
		SetSliderDialogDefaultValue(1)
	endif
	
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)

EndEvent

Event OnSliderAcceptST(float value)

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.ArgonianFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.BretonFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.DunmerFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.AltmerFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.ImperialFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.KhajiitFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.NordFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.OrcFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.RedguardFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerFamilyNameChance = value as int
		SetSliderOptionValueST(scrNameGen.BosmerFamilyNameChance, "{0}%")
	endif

EndEvent

Event OnDefaultST()

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianFamilyNameChance = 0
		SetSliderOptionValueST(scrNameGen.ArgonianFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonFamilyNameChance = 20
		SetSliderOptionValueST(scrNameGen.BretonFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerFamilyNameChance = 80
		SetSliderOptionValueST(scrNameGen.DunmerFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerFamilyNameChance = 10
		SetSliderOptionValueST(scrNameGen.AltmerFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialFamilyNameChance = 90
		SetSliderOptionValueST(scrNameGen.ImperialFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitFamilyNameChance = 0
		SetSliderOptionValueST(scrNameGen.KhajiitFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordFamilyNameChance = 23
		SetSliderOptionValueST(scrNameGen.NordFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcFamilyNameChance = 80
		SetSliderOptionValueST(scrNameGen.OrcFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardFamilyNameChance = 2
		SetSliderOptionValueST(scrNameGen.RedguardFamilyNameChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerFamilyNameChance = 1
		SetSliderOptionValueST(scrNameGen.BosmerFamilyNameChance, "{0}%")
	endif

EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that members of the selected Race will be assigned a Surname.")
EndEvent

EndState


State optFamilyNameOnly

Event OnSliderOpenST()

	if RaceSelectMenu[currentrace] == "Argonian"
		SetSliderDialogStartValue(scrNameGen.ArgonianFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Breton"
		SetSliderDialogStartValue(scrNameGen.BretonFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		SetSliderDialogStartValue(scrNameGen.DunmerFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "High Elf"
		SetSliderDialogStartValue(scrNameGen.AltmerFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Imperial"
		SetSliderDialogStartValue(scrNameGen.ImperialFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		SetSliderDialogStartValue(scrNameGen.KhajiitFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Nord"
		SetSliderDialogStartValue(scrNameGen.NordFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Orc"
		SetSliderDialogStartValue(scrNameGen.OrcFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Redguard"
		SetSliderDialogStartValue(scrNameGen.RedguardFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		SetSliderDialogStartValue(scrNameGen.BosmerFamilyNameOnlyChance)
		SetSliderDialogDefaultValue(0)
	endif
	
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)

EndEvent

Event OnSliderAcceptST(float value)

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.ArgonianFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.BretonFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.DunmerFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.AltmerFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.ImperialFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.KhajiitFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.NordFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.OrcFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.RedguardFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerFamilyNameOnlyChance = value as int
		SetSliderOptionValueST(scrNameGen.BosmerFamilyNameOnlyChance, "{0}%")
	endif

EndEvent

Event OnDefaultST()

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.ArgonianFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.BretonFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.DunmerFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.AltmerFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.ImperialFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.KhajiitFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.NordFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.OrcFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.RedguardFamilyNameOnlyChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerFamilyNameOnlyChance = 0
		SetSliderOptionValueST(scrNameGen.BosmerFamilyNameOnlyChance, "{0}%")
	endif

EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that members of the selected Race will be assigned a Surname instead of a first name. This check is independent of Surname Chance, and when applied will override any other Surname which would have been assigned.")
EndEvent

EndState


State optOffRaceName

Event OnSliderOpenST()

	if RaceSelectMenu[currentrace] == "Argonian"
		SetSliderDialogStartValue(scrNameGen.ArgonianOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Breton"
		SetSliderDialogStartValue(scrNameGen.BretonOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		SetSliderDialogStartValue(scrNameGen.DunmerOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "High Elf"
		SetSliderDialogStartValue(scrNameGen.AltmerOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Imperial"
		SetSliderDialogStartValue(scrNameGen.ImperialOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		SetSliderDialogStartValue(scrNameGen.KhajiitOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Nord"
		SetSliderDialogStartValue(scrNameGen.NordOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Orc"
		SetSliderDialogStartValue(scrNameGen.OrcOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Redguard"
		SetSliderDialogStartValue(scrNameGen.RedguardOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		SetSliderDialogStartValue(scrNameGen.BosmerOffRaceNameChance)
		SetSliderDialogDefaultValue(0)
	endif
	
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)

EndEvent

Event OnSliderAcceptST(float value)

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianOffRaceNameChance = value as int
		if value != 0 && scrNameGen.ArgonianBretonName == false && scrNameGen.ArgonianDunmerName == false && scrNameGen.ArgonianAltmerName == false && scrNameGen.ArgonianImperialName == false && scrNameGen.ArgonianKhajiitName == false && scrNameGen.ArgonianNordName == false && scrNameGen.ArgonianOrcName == false && scrNameGen.ArgonianRedguardName == false && scrNameGen.ArgonianBosmerName == false
			scrNameGen.ArgonianBretonName = true
			scrNameGen.ArgonianDunmerName = true
			scrNameGen.ArgonianAltmerName = true
			scrNameGen.ArgonianImperialName = true
			scrNameGen.ArgonianKhajiitName = true
			scrNameGen.ArgonianNordName = true
			scrNameGen.ArgonianOrcName = true
			scrNameGen.ArgonianRedguardName = true
			scrNameGen.ArgonianBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonOffRaceNameChance = value as int
		if value != 0 && scrNameGen.BretonArgonianName == false && scrNameGen.BretonDunmerName == false && scrNameGen.BretonAltmerName == false && scrNameGen.BretonImperialName == false && scrNameGen.BretonKhajiitName == false && scrNameGen.BretonNordName == false && scrNameGen.BretonOrcName == false && scrNameGen.BretonRedguardName == false && scrNameGen.BretonBosmerName == false
			scrNameGen.BretonArgonianName = true
			scrNameGen.BretonDunmerName = true
			scrNameGen.BretonAltmerName = true
			scrNameGen.BretonImperialName = true
			scrNameGen.BretonKhajiitName = true
			scrNameGen.BretonNordName = true
			scrNameGen.BretonOrcName = true
			scrNameGen.BretonRedguardName = true
			scrNameGen.BretonBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerOffRaceNameChance = value as int
		if value != 0 && scrNameGen.DunmerArgonianName == false && scrNameGen.DunmerBretonName == false && scrNameGen.DunmerAltmerName == false && scrNameGen.DunmerImperialName == false && scrNameGen.DunmerKhajiitName == false && scrNameGen.DunmerNordName == false && scrNameGen.DunmerOrcName == false && scrNameGen.DunmerRedguardName == false && scrNameGen.DunmerBosmerName == false
			scrNameGen.DunmerArgonianName = true
			scrNameGen.DunmerBretonName = true
			scrNameGen.DunmerAltmerName = true
			scrNameGen.DunmerImperialName = true
			scrNameGen.DunmerKhajiitName = true
			scrNameGen.DunmerNordName = true
			scrNameGen.DunmerOrcName = true
			scrNameGen.DunmerRedguardName = true
			scrNameGen.DunmerBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerOffRaceNameChance = value as int
		if value != 0 && scrNameGen.AltmerArgonianName == false && scrNameGen.AltmerBretonName == false && scrNameGen.AltmerDunmerName == false && scrNameGen.AltmerImperialName == false && scrNameGen.AltmerKhajiitName == false && scrNameGen.AltmerNordName == false && scrNameGen.AltmerOrcName == false && scrNameGen.AltmerRedguardName == false && scrNameGen.AltmerBosmerName == false
			scrNameGen.AltmerArgonianName = true
			scrNameGen.AltmerBretonName = true
			scrNameGen.AltmerDunmerName = true
			scrNameGen.AltmerImperialName = true
			scrNameGen.AltmerKhajiitName = true
			scrNameGen.AltmerNordName = true
			scrNameGen.AltmerOrcName = true
			scrNameGen.AltmerRedguardName = true
			scrNameGen.AltmerBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialOffRaceNameChance = value as int
		if value != 0 && scrNameGen.ImperialArgonianName == false && scrNameGen.ImperialBretonName == false && scrNameGen.ImperialDunmerName == false && scrNameGen.ImperialAltmerName == false && scrNameGen.ImperialKhajiitName == false && scrNameGen.ImperialNordName == false && scrNameGen.ImperialOrcName == false && scrNameGen.ImperialRedguardName == false && scrNameGen.ImperialBosmerName == false
			scrNameGen.ImperialArgonianName = true
			scrNameGen.ImperialBretonName = true
			scrNameGen.ImperialDunmerName = true
			scrNameGen.ImperialAltmerName = true
			scrNameGen.ImperialKhajiitName = true
			scrNameGen.ImperialNordName = true
			scrNameGen.ImperialOrcName = true
			scrNameGen.ImperialRedguardName = true
			scrNameGen.ImperialBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitOffRaceNameChance = value as int
		if value != 0 && scrNameGen.KhajiitArgonianName == false && scrNameGen.KhajiitBretonName == false && scrNameGen.KhajiitDunmerName == false && scrNameGen.KhajiitAltmerName == false && scrNameGen.KhajiitImperialName == false && scrNameGen.KhajiitNordName == false && scrNameGen.KhajiitOrcName == false && scrNameGen.KhajiitRedguardName == false && scrNameGen.KhajiitBosmerName == false
			scrNameGen.KhajiitArgonianName = true
			scrNameGen.KhajiitBretonName = true
			scrNameGen.KhajiitDunmerName = true
			scrNameGen.KhajiitAltmerName = true
			scrNameGen.KhajiitImperialName = true
			scrNameGen.KhajiitNordName = true
			scrNameGen.KhajiitOrcName = true
			scrNameGen.KhajiitRedguardName = true
			scrNameGen.KhajiitBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordOffRaceNameChance = value as int
		if value != 0 && scrNameGen.NordArgonianName == false && scrNameGen.NordBretonName == false && scrNameGen.NordDunmerName == false && scrNameGen.NordAltmerName == false && scrNameGen.NordImperialName == false && scrNameGen.NordKhajiitName == false && scrNameGen.NordOrcName == false && scrNameGen.NordRedguardName == false && scrNameGen.NordBosmerName == false
			scrNameGen.NordArgonianName = true
			scrNameGen.NordBretonName = true
			scrNameGen.NordDunmerName = true
			scrNameGen.NordAltmerName = true
			scrNameGen.NordImperialName = true
			scrNameGen.NordKhajiitName = true
			scrNameGen.NordOrcName = true
			scrNameGen.NordRedguardName = true
			scrNameGen.NordBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcOffRaceNameChance = value as int
		if value != 0 && scrNameGen.OrcArgonianName == false && scrNameGen.OrcBretonName == false && scrNameGen.OrcDunmerName == false && scrNameGen.OrcAltmerName == false && scrNameGen.OrcImperialName == false && scrNameGen.OrcKhajiitName == false && scrNameGen.OrcNordName == false && scrNameGen.OrcRedguardName == false && scrNameGen.OrcBosmerName == false
			scrNameGen.OrcArgonianName = true
			scrNameGen.OrcBretonName = true
			scrNameGen.OrcDunmerName = true
			scrNameGen.OrcAltmerName = true
			scrNameGen.OrcImperialName = true
			scrNameGen.OrcKhajiitName = true
			scrNameGen.OrcNordName = true
			scrNameGen.OrcRedguardName = true
			scrNameGen.OrcBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardOffRaceNameChance = value as int
		if value != 0 && scrNameGen.RedguardArgonianName == false && scrNameGen.RedguardBretonName == false && scrNameGen.RedguardDunmerName == false && scrNameGen.RedguardAltmerName == false && scrNameGen.RedguardImperialName == false && scrNameGen.RedguardKhajiitName == false && scrNameGen.RedguardNordName == false && scrNameGen.RedguardOrcName == false && scrNameGen.RedguardBosmerName == false
			scrNameGen.RedguardArgonianName = true
			scrNameGen.RedguardBretonName = true
			scrNameGen.RedguardDunmerName = true
			scrNameGen.RedguardAltmerName = true
			scrNameGen.RedguardImperialName = true
			scrNameGen.RedguardKhajiitName = true
			scrNameGen.RedguardNordName = true
			scrNameGen.RedguardOrcName = true
			scrNameGen.RedguardBosmerName = true
		endif
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerOffRaceNameChance = value as int
		if value != 0 && scrNameGen.BosmerArgonianName == false && scrNameGen.BosmerBretonName == false && scrNameGen.BosmerDunmerName == false && scrNameGen.BosmerAltmerName == false && scrNameGen.BosmerImperialName == false && scrNameGen.BosmerKhajiitName == false && scrNameGen.BosmerNordName == false && scrNameGen.BosmerOrcName == false && scrNameGen.BosmerRedguardName == false
			scrNameGen.BosmerArgonianName = true
			scrNameGen.BosmerBretonName = true
			scrNameGen.BosmerDunmerName = true
			scrNameGen.BosmerAltmerName = true
			scrNameGen.BosmerImperialName = true
			scrNameGen.BosmerKhajiitName = true
			scrNameGen.BosmerNordName = true
			scrNameGen.BosmerOrcName = true
			scrNameGen.BosmerRedguardName = true
		endif
	endif

	ForcePageReset()

EndEvent

Event OnDefaultST()

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardOffRaceNameChance = 0
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerOffRaceNameChance = 0
	endif

	ForcePageReset()

EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that members of the selected Race will be assigned an Off-race name.\n When applied, this will cause the first name, surname, or both to be those typical of another race.")
EndEvent

EndState


State optTitle

Event OnSliderOpenST()

	if RaceSelectMenu[currentrace] == "Argonian"
		SetSliderDialogStartValue(scrNameGen.ArgonianTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Breton"
		SetSliderDialogStartValue(scrNameGen.BretonTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		SetSliderDialogStartValue(scrNameGen.DunmerTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "High Elf"
		SetSliderDialogStartValue(scrNameGen.AltmerTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Imperial"
		SetSliderDialogStartValue(scrNameGen.ImperialTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		SetSliderDialogStartValue(scrNameGen.KhajiitTitleChance)
		SetSliderDialogDefaultValue(1)
	elseif RaceSelectMenu[currentrace] == "Nord"
		SetSliderDialogStartValue(scrNameGen.NordTitleChance)
		SetSliderDialogDefaultValue(20)
	elseif RaceSelectMenu[currentrace] == "Orc"
		SetSliderDialogStartValue(scrNameGen.OrcTitleChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Redguard"
		SetSliderDialogStartValue(scrNameGen.RedguardTitleChance)
		SetSliderDialogDefaultValue(2)
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		SetSliderDialogStartValue(scrNameGen.BosmerTitleChance)
		SetSliderDialogDefaultValue(1)
	endif
	
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)

EndEvent

Event OnSliderAcceptST(float value)

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.ArgonianTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.BretonTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.DunmerTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.AltmerTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.ImperialTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.KhajiitTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.NordTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.OrcTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.RedguardTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerTitleChance = value as int
		SetSliderOptionValueST(scrNameGen.BosmerTitleChance, "{0}%")
	endif

EndEvent

Event OnDefaultST()

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianTitleChance = 0
		SetSliderOptionValueST(scrNameGen.ArgonianTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonTitleChance = 0
		SetSliderOptionValueST(scrNameGen.BretonTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerTitleChance = 0
		SetSliderOptionValueST(scrNameGen.DunmerTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerTitleChance = 0
		SetSliderOptionValueST(scrNameGen.AltmerTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialTitleChance = 0
		SetSliderOptionValueST(scrNameGen.ImperialTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitTitleChance = 1
		SetSliderOptionValueST(scrNameGen.KhajiitTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordTitleChance = 20
		SetSliderOptionValueST(scrNameGen.NordTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcTitleChance = 0
		SetSliderOptionValueST(scrNameGen.OrcTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardTitleChance = 2
		SetSliderOptionValueST(scrNameGen.RedguardTitleChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerTitleChance = 1
		SetSliderOptionValueST(scrNameGen.BosmerTitleChance, "{0}%")
	endif

EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that members of the selected Race will be assigned an Title before their name.")
EndEvent

EndState


State optEpithet

Event OnSliderOpenST()

	if RaceSelectMenu[currentrace] == "Argonian"
		SetSliderDialogStartValue(scrNameGen.ArgonianEpithetChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Breton"
		SetSliderDialogStartValue(scrNameGen.BretonEpithetChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		SetSliderDialogStartValue(scrNameGen.DunmerEpithetChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "High Elf"
		SetSliderDialogStartValue(scrNameGen.AltmerEpithetChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Imperial"
		SetSliderDialogStartValue(scrNameGen.ImperialEpithetChance)
		SetSliderDialogDefaultValue(0)
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		SetSliderDialogStartValue(scrNameGen.KhajiitEpithetChance)
		SetSliderDialogDefaultValue(1)
	elseif RaceSelectMenu[currentrace] == "Nord"
		SetSliderDialogStartValue(scrNameGen.NordEpithetChance)
		SetSliderDialogDefaultValue(20)
	elseif RaceSelectMenu[currentrace] == "Orc"
		SetSliderDialogStartValue(scrNameGen.OrcEpithetChance)
		SetSliderDialogDefaultValue(1)
	elseif RaceSelectMenu[currentrace] == "Redguard"
		SetSliderDialogStartValue(scrNameGen.RedguardEpithetChance)
		SetSliderDialogDefaultValue(2)
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		SetSliderDialogStartValue(scrNameGen.BosmerEpithetChance)
		SetSliderDialogDefaultValue(1)
	endif
	
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)

EndEvent

Event OnSliderAcceptST(float value)

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.ArgonianEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.BretonEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.DunmerEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.AltmerEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.ImperialEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.KhajiitEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.NordEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.OrcEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.RedguardEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerEpithetChance = value as int
		SetSliderOptionValueST(scrNameGen.BosmerEpithetChance, "{0}%")
	endif

EndEvent

Event OnDefaultST()

	if RaceSelectMenu[currentrace] == "Argonian"
		scrNameGen.ArgonianEpithetChance = 0
		SetSliderOptionValueST(scrNameGen.ArgonianEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Breton"
		scrNameGen.BretonEpithetChance = 0
		SetSliderOptionValueST(scrNameGen.BretonEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Dark Elf"
		scrNameGen.DunmerEpithetChance = 0
		SetSliderOptionValueST(scrNameGen.DunmerEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "High Elf"
		scrNameGen.AltmerEpithetChance = 0
		SetSliderOptionValueST(scrNameGen.AltmerEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Imperial"
		scrNameGen.ImperialEpithetChance = 0
		SetSliderOptionValueST(scrNameGen.ImperialEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Khajiit"
		scrNameGen.KhajiitEpithetChance = 1
		SetSliderOptionValueST(scrNameGen.KhajiitEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Nord"
		scrNameGen.NordEpithetChance = 20
		SetSliderOptionValueST(scrNameGen.NordEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Orc"
		scrNameGen.OrcEpithetChance = 1
		SetSliderOptionValueST(scrNameGen.OrcEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Redguard"
		scrNameGen.RedguardEpithetChance = 2
		SetSliderOptionValueST(scrNameGen.RedguardEpithetChance, "{0}%")
	elseif RaceSelectMenu[currentrace] == "Wood Elf"
		scrNameGen.BosmerEpithetChance = 1
		SetSliderOptionValueST(scrNameGen.BosmerEpithetChance, "{0}%")
	endif

EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that members of the selected Race will be assigned an Epithet after their name.")
EndEvent

EndState


State optPrefixChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.OrcFamilyPrefixChance)
	SetSliderDialogDefaultValue(100)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.OrcFamilyPrefixChance = value as int
	SetSliderOptionValueST(scrNameGen.OrcFamilyPrefixChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.OrcFamilyPrefixChance = 100
	SetSliderOptionValueST(scrNameGen.OrcFamilyPrefixChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Orc clan names will have the 'gro' or 'gra' prefix affixed.")
EndEvent

EndState


State optNordPatronym

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.NordPatronymicChance)
	SetSliderDialogDefaultValue(25)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.NordPatronymicChance = value as int
	SetSliderOptionValueST(scrNameGen.NordPatronymicChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.NordPatronymicChance = 25
	SetSliderOptionValueST(scrNameGen.NordPatronymicChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Nords will be assigned a patronymic/matronymic instead of a clan name.")
EndEvent

EndState


State optDraugrPatronym

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DraugrPatronymicChance)
	SetSliderDialogDefaultValue(100)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DraugrPatronymicChance = value as int
	SetSliderOptionValueST(scrNameGen.DraugrPatronymicChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DraugrPatronymicChance = 100
	SetSliderOptionValueST(scrNameGen.DraugrPatronymicChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Draugr will be assigned a patronymic/matronymic instead of a clan name.")
EndEvent

EndState


State optMalePrefixChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.KhajiitMalePrefixChance)
	SetSliderDialogDefaultValue(90)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.KhajiitMalePrefixChance = value as int
	SetSliderOptionValueST(scrNameGen.KhajiitMalePrefixChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.KhajiitMalePrefixChance = 90
	SetSliderOptionValueST(scrNameGen.KhajiitMalePrefixChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Khajiit males will be assigned an honorific prefix.")
EndEvent

EndState


State optFemalePrefixChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.KhajiitFemalePrefixChance)
	SetSliderDialogDefaultValue(5)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.KhajiitFemalePrefixChance = value as int
	SetSliderOptionValueST(scrNameGen.KhajiitFemalePrefixChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.KhajiitFemalePrefixChance = 5
	SetSliderOptionValueST(scrNameGen.KhajiitFemalePrefixChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Khajiit females will be assigned an honorific prefix.")
EndEvent

EndState


State optMaleSuffixChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.KhajiitMaleSuffixChance)
	SetSliderDialogDefaultValue(10)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.KhajiitMaleSuffixChance = value as int
	SetSliderOptionValueST(scrNameGen.KhajiitMaleSuffixChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.KhajiitMaleSuffixChance = 10
	SetSliderOptionValueST(scrNameGen.KhajiitMaleSuffixChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Khajiit males will be assigned an honorific suffix.")
EndEvent

EndState


State optFemaleSuffixChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.KhajiitFemaleSuffixChance)
	SetSliderDialogDefaultValue(1)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.KhajiitFemaleSuffixChance = value as int
	SetSliderOptionValueST(scrNameGen.KhajiitFemaleSuffixChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.KhajiitFemaleSuffixChance = 1
	SetSliderOptionValueST(scrNameGen.KhajiitFemaleSuffixChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Khajiit females will be assigned an honorific suffix.")
EndEvent

EndState


State optAshlanderChance

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DunmerAshlanderChance)
	SetSliderDialogDefaultValue(5)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DunmerAshlanderChance = value as int
	SetSliderOptionValueST(scrNameGen.DunmerAshlanderChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DunmerAshlanderChance = 5
	SetSliderOptionValueST(scrNameGen.DunmerAshlanderChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Dark Elves will be assigned a traditional Ashlander name.")
EndEvent

EndState


State optBossSir

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.BossSirChance)
	SetSliderDialogDefaultValue(30)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.BossSirChance = value as int
	SetSliderOptionValueST(scrNameGen.BossSirChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.BossNameChance = 30
	SetSliderOptionValueST(scrNameGen.BossSirChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Bosses (determined by Boss Search Terms) will be assigned a Moniker before their name.\n When applied, this Moniker will override any other Title which would have been assigned.")
EndEvent

EndState


State optBossName

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.BossNameChance)
	SetSliderDialogDefaultValue(30)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.BossNameChance = value as int
	SetSliderOptionValueST(scrNameGen.BossNameChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.BossNameChance = 30
	SetSliderOptionValueST(scrNameGen.BossNameChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Bosses (determined by Boss Search Terms) will be assigned a Moniker after their name.\n When applied, this Moniker will override any other Epithet which would have been assigned.")
EndEvent

EndState


State optDraugrTitle

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DraugrTitleChance)
	SetSliderDialogDefaultValue(0)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DraugrTitleChance = value as int
	SetSliderOptionValueST(scrNameGen.DraugrTitleChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DraugrTitleChance = 0
	SetSliderOptionValueST(scrNameGen.DraugrTitleChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Draugr will be assigned a Title before their name.")
EndEvent

EndState


State optDraugrEpithet

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DraugrEpithetChance)
	SetSliderDialogDefaultValue(50)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DraugrEpithetChance = value as int
	SetSliderOptionValueST(scrNameGen.DraugrEpithetChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DraugrEpithetChance = 50
	SetSliderOptionValueST(scrNameGen.DraugrEpithetChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Draugr will be assigned an Epithet after their name.")
EndEvent

EndState


State optDraugrFamilyName

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DraugrFamilyNameChance)
	SetSliderDialogDefaultValue(75)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DraugrFamilyNameChance = value as int
	SetSliderOptionValueST(scrNameGen.DraugrFamilyNameChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DraugrFamilyNameChance = 75
	SetSliderOptionValueST(scrNameGen.DraugrFamilyNameChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Draugr will be assigned a Nord Clan Name.")
EndEvent

EndState


State optDremoraTitle

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DremoraTitleChance)
	SetSliderDialogDefaultValue(5)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DremoraTitleChance = value as int
	SetSliderOptionValueST(scrNameGen.DremoraTitleChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DremoraFamilyNameChance = 5
	SetSliderOptionValueST(scrNameGen.DremoraTitleChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Dremora will be assigned a Title before their name.")
EndEvent

EndState


State optDremoraEpithet

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DremoraEpithetChance)
	SetSliderDialogDefaultValue(5)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DremoraEpithetChance = value as int
	SetSliderOptionValueST(scrNameGen.DremoraEpithetChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DremoraEpithetChance = 5
	SetSliderOptionValueST(scrNameGen.DremoraEpithetChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Dremora will be assigned an Epithet after their name.")
EndEvent

EndState


State optDremoraFamilyName

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DremoraFamilyNameChance)
	SetSliderDialogDefaultValue(1)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DremoraFamilyNameChance = value as int
	SetSliderOptionValueST(scrNameGen.DremoraFamilyNameChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DremoraFamilyNameChance = 1
	SetSliderOptionValueST(scrNameGen.DremoraFamilyNameChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that renamed Dremora will be assigned a Kyn (Clan) Name.")
EndEvent

EndState


State optDragonSyllable

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.Dragon3SyllableChance)
	SetSliderDialogDefaultValue(50)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.Dragon3SyllableChance = value as int
	SetSliderOptionValueST(scrNameGen.Dragon3SyllableChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.Dragon3SyllableChance = 50
	SetSliderOptionValueST(scrNameGen.Dragon3SyllableChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Set the chance that Dragon Names assigned will contain three one-syllable name words.")
EndEvent

EndState


State optDragonPriest1Syllable

Event OnSliderOpenST()
	SetSliderDialogStartValue(scrNameGen.DragonPriest1SyllableChance)
	SetSliderDialogDefaultValue(20)
	SetSliderDialogRange(0,100)
	SetSliderDialogInterval(1)
EndEvent

Event OnSliderAcceptST(float value)
	scrNameGen.DragonPriest1SyllableChance = value as int
	SetSliderOptionValueST(scrNameGen.DragonPriest1SyllableChance, "{0}%")
EndEvent

Event OnDefaultST()
	scrNameGen.DragonPriest1SyllableChance = 20
	SetSliderOptionValueST(scrNameGen.DragonPriest1SyllableChance, "{0}%")
EndEvent

Event OnHighlightST()
	SetInfoText("Dragon Priests are assigned names from the Dragon Name Words lists.\nSet the chance that Dragon Priest Names assigned will contain just one name word.")
EndEvent

EndState